// Copyright © 2017 Project Golan, all rights reserved.
#ifndef g_object_h
#define g_object_h

#include "g_objdef.h"

#include <Doominati.h>

#define G_propMemOfs(ofs, t, name) \
   __prop name {__get: DGE_Object_MemberGet(t, ->id, ofs), \
                __set: DGE_Object_MemberSet(t, ->id, ofs)}

#define G_propMemFcn(ofs, fn, name) \
   __prop name {__get: fn##Get(->id, ofs), \
                __set: fn##Set(->id, ofs)}

#define G_propMemExt(base, ofs, t, name) \
   G_propMemOfs(DGE_OME_##base + (ofs), t, name)

#define G_Entity_propMem(ofs, t, name) G_propMemExt(Entity, ofs, t, name)
#define G_RenderThinker_propMem(ofs, t, name) \
   G_propMemExt(RenderThinker, ofs, t, name)

#define G_RenderThinker_propExt() \
   G_propMemOfs(DGE_OME(RenderThinker.frame), unsigned, frame) \
   G_propMemOfs(DGE_OME(RenderThinker.ftime), unsigned, ftime) \
   G_propMemFcn(DGE_OME(RenderThinker.curanim), G_Object_Anim, curanim) \
   __prop animate  {__call: G_RenderThinker_Animate(->id)} \
   __prop setAnim  {__call: G_RenderThinker_AnimSet(->id)} \
   __prop fsetAnim {__call: G_RenderThinker_AnimSetForced(->id)}

#define G_Entity_propExt() \
   G_propMemOfs(DGE_OME(Entity.subtype), int, subtype)

// Extern Functions ----------------------------------------------------------|

G_anima const *G_Object_AnimGet(unsigned id, unsigned ofs);
void           G_Object_AnimSet(unsigned id, unsigned ofs, G_anima const *an);

void G_RenderThinker_Animate(unsigned id);
void G_RenderThinker_AnimSet(unsigned id, G_anima const *anim);
void G_RenderThinker_AnimSetForced(unsigned id, G_anima const *anim);

// Types ---------------------------------------------------------------------|

enum G_subty
{
   subtype_none,
   subtype_missile,
   subtype_test,
   subtype_player,
   subtype_max,
};

#define G_RenderThinker_props() DGE_RenderThinkerProps() \
   G_RenderThinker_propExt()
typedef struct G_rthnk // Render Thinker
{
   int id;

   G_RenderThinker_props()
} G_rthnk;

#define G_Entity_props() DGE_EntityProps() \
   G_RenderThinker_propExt() \
   G_Entity_propExt()
typedef struct G_entit // Entity
{
   int id;

   G_Entity_props()
} G_entit;

#define G_Missile_props() DGE_MissileEntityProps() \
   G_RenderThinker_propExt() \
   G_Entity_propExt()
typedef struct G_missl // Missile
{
   int id;

   G_Missile_props()
} G_missl;

// Extern Functions ----------------------------------------------------------|

void G_Entity_Create(union G_mfdat *info);
void G_Sector_Create(union G_mfdat *info);

#endif
